package hk.quantr.assembler.ia32;

import hk.quantr.assembler.print.MessageHandler;
import java.util.Arrays;
import java.util.LinkedHashSet;
import java.util.Set;
import java.util.regex.Pattern;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Peter
 */
public class CopyTestCaseFromPDFFrame extends javax.swing.JFrame {

	/**
	 * Creates new form CopyTestCaseFromPDFFrame
	 */
	public CopyTestCaseFromPDFFrame() {
		initComponents();
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jPanel1 = new javax.swing.JPanel();
        encodeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Copy test case");
        setSize(new java.awt.Dimension(800, 800));

        jScrollPane1.setViewportView(jTextPane1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        encodeButton.setText("Encode");
        encodeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                encodeButtonActionPerformed(evt);
            }
        });
        jPanel1.add(encodeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_START);
    }// </editor-fold>//GEN-END:initComponents

    private void encodeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_encodeButtonActionPerformed
		String arr[] = TestUtil.translatedMap.keySet().toArray(new String[0]);
		String text = jTextPane1.getText();
		//Arrays.sort(arr, Collections.reverseOrder());
		Arrays.sort(arr, (a, b) -> Integer.compare(b.length(), a.length()));
		String regex = "(?<!^\\w+)(" + String.join("|", arr).replace("${", "").replace("}", "") + ")";
		System.out.println(regex);
		String temp = Pattern.compile(regex, Pattern.MULTILINE).matcher(text.toLowerCase()).replaceAll("\\${$1}");
		temp = temp.replace("*", "");
		Set<String> set = new LinkedHashSet<>();
		for (String t : temp.split("\n")) {
			set.add(t);
		}
		temp = String.join("\n", set);
		jTextPane1.setText(temp);
    }//GEN-LAST:event_encodeButtonActionPerformed

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		/* Set the Nimbus look and feel */
		//<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
		/* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
		 */
		try {
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
				if ("Nimbus".equals(info.getName())) {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());
					break;
				}
			}
		} catch (ClassNotFoundException ex) {
			MessageHandler.errorPrintln(ex);
		} catch (InstantiationException ex) {
			MessageHandler.errorPrintln(ex);
		} catch (IllegalAccessException ex) {
			MessageHandler.errorPrintln(ex);
		} catch (javax.swing.UnsupportedLookAndFeelException ex) {
			MessageHandler.errorPrintln(ex);
		}
		//</editor-fold>
		//</editor-fold>

		/* Create and display the form */
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new CopyTestCaseFromPDFFrame().setVisible(true);
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton encodeButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane jTextPane1;
    // End of variables declaration//GEN-END:variables
}
